#include "OSD.h"

#include "System.h"

#include "I2C.h"


#include "Arduino.h"

unsigned char m_OSDInitTab[]=   
{   
    0x4C,   //H Start                           (4*0x60+12 = 396 pixel) 0x00   
    0x0D,   //V Start                           (4*0x20+1  = 129 line)  0x01   
    0x0F,   //H Width                           (  0x0C+1  = 13 char)   0x02      
    0x07,   //V Height                          (  0x00+1  = 1  char)   0x03   
    0x00,   //H Space Start position            (  0x00    = 0  char)   0x04   
    0x00,   //V Space Start position            (  0x00    = 0  char)   0x05   
    0x00,   //H Space Width                     (  0x00*8  = 0  pixel)  0x06   
    0x00,   //V Space Heigth                    (  0x00*8  = 0  line)   0x07   
    0x03,   //Ctrl. Reg D7-6 Vert. scaling      (Vert. enlarged x1)     0x08   
            //          D5-4 Horz. scaling      (Horz. enlarged x1)   
            //          D2 All Sub OSD window display      
            //          D1 Type of Char. border (bottom-right)   
            //          D0 Main OSD windows display   
            //              0: OSD window OFF   (OSD OFF)   
            //              1: OSD window ON   
    0x30    //Misc. Ctrl                                                0x09   
};




unsigned char m_RamFontTab[]=   
{   
    0xFF,0x0F,0xFF,0x0F,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x7F,0x0C,0x7F,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,//LT   
    0xFF,0x0F,0xFF,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x0F,0xFF,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//T   
    0xFF,0x0F,0xFF,0x0F,0x03,0x00,0x03,0x00,0x03,0x00,0xE3,0x0F,0xE3,0x0F,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,//RT       
    0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,//R   
    0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0x63,0x00,0xE3,0x0F,0xE3,0x0F,0x03,0x00,0x03,0x00,0x03,0x00,0xFF,0x0F,0xFF,0x0F,//RB   
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x0F,0xFF,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x0F,0xFF,0x0F, //B   
    0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x7F,0x0C,0x7F,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0xFF,0x0F,0xFF,0x0F,//LB   
    0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C,0x60,0x0C//L   
}; 


unsigned char MXIC_WriteExternalReg(unsigned char m_Address,unsigned char m_Data)   
{   
    I2C_WriteByte(MXIC_ID,m_Address,m_Data);   
    return m_Data;     
} 
unsigned char MXIC_ReadExternalReg(unsigned char m_Address)   
{   
        return I2C_ReadByte(MXIC_ID,m_Address);    
        
}
unsigned char MXIC_OSDReg_Write(unsigned char m_Target,unsigned int m_Address,unsigned char *m_Data,unsigned int m_Count)   
{   
    int i,m_Offset=0;   
    int j;   
    unsigned char m_Address_H;   
    unsigned char m_Address_L;   
    MXIC_WriteExternalReg(OSD_RW_CTRL,m_Target|0x80);//Burst Mode Write   
    m_Address_H=(unsigned char)(m_Address/0x100);   
    m_Address_L=(unsigned char)(m_Address-OSD_ADDRESS_H*0x100);   
    MXIC_WriteExternalReg(OSD_ADDRESS_H,m_Address_H);   
    MXIC_WriteExternalReg(OSD_ADDRESS_L,m_Address_L);   
    switch(m_Target)   
    {                                        
        case OSD_CTRL_REG:   
            for(i=0;i<m_Count;i++)   
            {   
                MXIC_WriteExternalReg(OSD_DATA_L,m_Data[i]);   
            }   
            break;   
        case OSD_FONT_RAM:   
            for(i=0,m_Offset=0;i<m_Count;i++)   
            //for(i=0; i<m_Count;i++)   
            {   
                for(j=0;j<18;j++)   
                {   
                    MXIC_WriteExternalReg(OSD_DATA_L,m_Data[m_Offset]);   
                    MXIC_WriteExternalReg(OSD_DATA_H,m_Data[m_Offset+1]);   
                    m_Offset+=2;                   
                }   
            }   
            break;   
        case OSD_CODE_BUFFER:   
            for(i=0,m_Offset=0;i<m_Count;i++,m_Offset+=2)   
               
            {   
                MXIC_WriteExternalReg(OSD_DATA_L,m_Data[m_Offset]);   
                MXIC_WriteExternalReg(OSD_DATA_H,m_Data[m_Offset+1]);                                  
            }   
            break;   
        case OSD_ATTR_REG:   
            for(i=0,m_Offset=0;i<m_Count;i++,m_Offset+=2)   
            {   
                MXIC_WriteExternalReg(OSD_DATA_L,m_Data[m_Offset]);   
                MXIC_WriteExternalReg(OSD_DATA_H,m_Data[m_Offset+1]);                                  
            }   
            break;   
    }   
    MXIC_WriteExternalReg(OSD_RW_CTRL,0x04);//Disable OSD Read_Write Mode   
    return 1;              
}   



unsigned char MXIC_OSDReg_SingleWrite(unsigned char m_Target,unsigned short m_Address,unsigned char m_HighByte,unsigned char m_LowByte)   
{   
    unsigned char m_Address_H;   
    unsigned char m_Address_L;   
    MXIC_WriteExternalReg(OSD_RW_CTRL,m_Target&0x7F);//Single Mode Write   
    m_Address_H=(unsigned char)(m_Address/0x100);   
    m_Address_L=(unsigned char)(m_Address-OSD_ADDRESS_H*0x100);   
    MXIC_WriteExternalReg(OSD_ADDRESS_H,m_Address_H);   
    MXIC_WriteExternalReg(OSD_ADDRESS_L,m_Address_L);   
    MXIC_WriteExternalReg(OSD_DATA_L,m_LowByte);   
    MXIC_WriteExternalReg(OSD_DATA_H,m_HighByte);   
    return 1;   
}
unsigned char ASCII_TO_FONTIndex(unsigned char m_AnyChar)   
{   
    unsigned char index=0;   
    if(m_AnyChar>=48 && m_AnyChar<=57) //0--9   
    {   
        index=m_AnyChar-48;   
    }   
    else if(m_AnyChar>=65 && m_AnyChar<=90)//A--Z   
    {   
        index=m_AnyChar-65+10;   
    }   
    else if(m_AnyChar>=97 && m_AnyChar<=122)//a--z   
    {   
        index=m_AnyChar-97+37;   
    }   
    else if(m_AnyChar>=128)   
    {   
        index=m_AnyChar-128;   
        index|=0x80;   
    }   
    else    
    {   
        switch(m_AnyChar)   
        {   
            case '-':   
                index=85;   
                break;   
            case '/':   
                index=86;   
                break;   
            case '&':   
                index=87;   
                break;   
            case '+':   
                index=88;   
                break;                                
            case '.':   
                index=120;   
                break;   
            case ',':   
                index=121;   
                break;   
            case ';':   
                index=122;   
                break;   
            case ':':   
                index=123;   
                break;   
            case '?':   
                index=124;   
                break;   
            case '!':   
                index=125;   
                break;   
            case '%':   
                index=126;   
                break;   
            case '=':   
                index=127;   
                break;   
            case '*':   
                index=128;   
                break;   
            case ' ':   
                index=0x59;   
                break;   
        }   
    }      
    return index;   
}   
unsigned char MXIC_OSD_ShowText(unsigned char *m_Str,unsigned char m_Count,unsigned char m_RowVal,unsigned char m_ColVal)   
{   
    unsigned char m_DisplayBuffer[MXIC_CHAR_COUNT_PER_LINE*2]={' '};   
    unsigned char m_AttributeBuffer[MXIC_CHAR_COUNT_PER_LINE*2]={' '};   
    int i,j;   
//  MXIC_WriteExternalReg(OSD_RW_CTRL,0x42); //CLEAR CODE BUFFER with 0x59   
    for(i=0,j=0;i<m_Count;j+=2,i++)   
    {   
         m_DisplayBuffer[j]=ASCII_TO_FONTIndex(m_Str[i]);   
         m_DisplayBuffer[j+1]=0x04;   
    }                                                                 
    MXIC_OSDReg_Write(OSD_CODE_BUFFER,(m_RowVal*OSD_COL_COUNT+m_ColVal),m_DisplayBuffer,m_Count);   
       
//  for(i=0;i<m_Count;i++)   
//  {   
//     m_AttributeBuffer[i]=0x0E;   
//     m_AttributeBuffer[i+1]=0x01;   
//  }   
//  UPD5300_OSDReg_Write(OSD_ATTR_REG,(m_RowVal*OSD_COL_COUNT+m_ColVal),m_AttributeBuffer,m_Count);                                                     
    return 1;   
}  
unsigned char OSD_AutoLoadRamFont(void)                        
{   
    return MXIC_OSDReg_Write(OSD_FONT_RAM,0x00,m_RamFontTab,8);   
}

unsigned char OSD_Initial(void)   
{   
    unsigned char m_RetVal;   
    unsigned char mm[10]={0};   
    MXIC_WriteExternalReg(OSD_ENABLE,0x0D);   
    m_RetVal=MXIC_ReadExternalReg(OSD_ENABLE);   
    m_RetVal|=0x80;   
    MXIC_WriteExternalReg(OSD_ENABLE,m_RetVal);   
   
    OSD_AutoLoadRamFont();   
    MXIC_WriteExternalReg(OSD_ENABLE,0x80);//OSD ENABLE ALPHA DISABLE   
    MXIC_OSDReg_Write(OSD_CTRL_REG,0x00,m_OSDInitTab,sizeof(m_OSDInitTab));   
    mm[0]=0x19;   
    mm[1]=0x0A;   
    mm[2]=0x01;   
    mm[3]=0x55;   
    MXIC_OSDReg_Write(OSD_CTRL_REG,0x0C,mm,4);   
   
    MXIC_WriteExternalReg(0x17,0x00);   
    MXIC_WriteExternalReg(0x18,0x00);   
    MXIC_WriteExternalReg(0x19,0xFF);   
   
    return 1;      
}
unsigned char OSD_ShowText(unsigned char *m_Str,unsigned char m_Count,unsigned int xPos,unsigned int yPos)   
{   
    MXIC_WriteExternalReg(OSD_RW_CTRL,0x42); //CLEAR CODE BUFFER with 0x59   
    MXIC_OSDReg_SingleWrite(OSD_CTRL_REG,0x00,0x00,xPos);    //H-START POS   
    MXIC_OSDReg_SingleWrite(OSD_CTRL_REG,0x01,0x00,yPos);    //V-START POS   
    MXIC_OSDReg_SingleWrite(OSD_CTRL_REG,0x02,0x00,m_Count-1); //H-WIDTH POS   
    MXIC_OSDReg_SingleWrite(OSD_CTRL_REG,0x03,0x00,0);    //V-HEIGHT POS   
    MXIC_OSDReg_SingleWrite(OSD_CTRL_REG,0x09,0x00,0);    //V-HEIGHT POS   
   
    MXIC_OSD_ShowText(m_Str,m_Count,0,0);   
    return 1;   
}  
